/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.accordproject.calendar

// imports
import {IDuration} from './org.accordproject.time';
import {IGeoCoordinates} from './org.accordproject.geo';
import {IAsset} from './concerto';

// interfaces
export interface ICalendarComponent extends IAsset {
   uid: string;
}

export interface IUniqueComponent extends ICalendarComponent {
   attendee?: string[];
   comment?: string[];
   dtstamp?: Date;
   organizer?: string;
   requestStatuses?: string[];
   url?: string;
}

export interface IRecurringComponent extends IUniqueComponent {
   attachements?: string[];
   categories?: string[];
   classType?: string;
   contacts?: string[];
   created?: Date;
   description?: string;
   lastModified?: Date;
   priority?: number;
   related?: string[];
   sequence?: number;
   summary?: string;
}

export interface IVAlarm extends ICalendarComponent {
   alarmAction?: string;
   attachment?: string;
   attendees?: string[];
   description?: string;
   duration?: IDuration;
   repeat?: number;
   summary?: string;
}

export interface IVEvent extends IRecurringComponent {
   dtend?: Date;
   duration?: IDuration;
   end?: Date;
   isAllDay?: boolean;
   geo?: IGeoCoordinates;
   location?: string;
   resources?: string[];
   transparency?: string;
   isActive?: boolean;
}

export interface IVFreebusy extends IUniqueComponent {
   dtstart?: Date;
   dtend?: Date;
   start?: Date;
   end?: Date;
}

export interface IVJournal extends IRecurringComponent {
}

export interface IVTodo extends IRecurringComponent {
   completed?: Date;
   due?: Date;
   duration?: IDuration;
   geo?: IGeoCoordinates;
   location?: string;
   percentComplete?: number;
   resources?: string[];
   todo?: string;
}

